<?
  define("VERTICE_INICIO","iniciografoaquininguem");
  define("VERTICE_FIM","fimgrafoaquininguem");

  srand(time());        //Numeros randomicos


  function insereLigacao(&$Grafo,$de,$para){
           if($Grafo[$de] == NULL){
               $Grafo[$de] = Array();
           }

           if (!array_key_exists($para, $Grafo[$de])) {
                $Grafo[$de][$para] = 1;
           }else{
                $Grafo[$de][$para]++;
           }
  }

  function inicioGrafo($ordem){
	   $word = Array();
           for($i = 0; $i < $ordem; $i++)
                $word[] = VERTICE_INICIO;
           return $word;
  }

  function palavrasNodo($palavras){
          return implode(" ",$palavras);
 }

  function adicionarNoGrafo($Paragrafo,&$Grafo,$ordem){
           $Paragrafo = trim($Paragrafo);

           if( $Grafo == NULL ){
               $Grafo = Array();
           }

           $Palavras = explode(" ",$Paragrafo);
	   $lastWord = inicioGrafo($ordem);
           for($i = 0; $i < sizeof($Palavras); $i++){
           	$A_Palavra = trim($Palavras[$i]);
                if($A_Palavra != ""){
                	insereLigacao($Grafo,palavrasNodo($lastWord),$A_Palavra);
                	$lastWord[] = $A_Palavra;
		  	array_shift($lastWord);
                  }
           }
	   for($i = 0; $i < $ordem; $i++){
	        insereLigacao($Grafo,palavrasNodo($lastWord),VERTICE_FIM);
		array_shift($lastWord);
		$lastWord[] = VERTICE_FIM;           	
	   }
  }

  function criaGrafo($texto,$ordem){
           $texto = strtolower($texto);
           $paragrafos = explode("\n",$texto);
           $Grafo = Array();	
	$paragrafos = array_unique($paragrafos);
	
          adicionarNoGrafo("",$Grafo,$ordem);
	  foreach ($paragrafos as $paragrafo){
              adicionarNoGrafo($paragrafo,$Grafo,$ordem);
          }
	  $Grafo[palavrasNodo(inicioGrafo($ordem))][VERTICE_FIM] = 0;
          return $Grafo;
  }

  function pegaProximoAleatorio(&$Arestas){
	$proximos = array_keys($Arestas);
        $proximo = $proximos[(rand()%sizeof($proximos))];
	return $proximo;
  }
 
  function pegaProximoProporcional(&$Arestas){
	$intervals = Array();
	$last = 0;
	foreach($Arestas as $chave => $valor){
		$intervals[$chave] = Array($last,$last+$valor);
		$last += $valor;
	}
	if($last == 0) return VERTICE_FIM;
	$escolhido = rand()%$last;
	foreach($intervals as $chave => $valor)
		if($valor[0] <= $escolhido && $valor[1] > $escolhido)
			return $chave;
  }

  function caminhGrafoERetornaParagrafo(&$Grafo,$ordem){
       $nodo = inicioGrafo($ordem);
       $paragrafo = "";
       while(!in_array(VERTICE_FIM,$nodo)){
             $proximo = pegaProximoProporcional($Grafo[palavrasNodo($nodo)]);
             if($proximo !=  VERTICE_FIM )
                 $paragrafo = $paragrafo." ".$proximo;
             $nodo[] = $proximo;
	     array_shift($nodo);
       }
       return $paragrafo;
  }

    $ordem = $_GET["ordem"];
    if(!is_numeric($ordem) || $ordem <= 0 || $ordem > 10) {
        $ordem = 1;
	echo "Colocando a ordem num intervalo seguro: [1,10] <br/>";
    }
    $grafo = criaGrafo(file_get_contents($_GET["band"]),$ordem);
//    $ordem = 2;
//    $grafo = criaGrafo(file_get_contents("cpm22.txt"),$ordem);

//  $grafo = criaGrafo($_POST["musicas_nomes"]);

?>
<!doctype html public "-//W3C//DTD HTML 4.0 //EN"> 
<html>
<head>
       <title>Uma musica do CPM 22?</title>
	<!-- <meta http-equiv="content-type" content="text-html; charset=utf-8"> -->
</head>
<body>
<br />
<!-- <pre>
     <? //var_dump($grafo) ?>
</pre>-->
<br />
	<font size="2">	
<?
	//Tries
	$tot = 0;
	for($i = 0; $i < 100 && $tot < 12; $i++){
		$para = caminhGrafoERetornaParagrafo($grafo,$ordem);
		if($para == "") continue;
		$tot++;
		if($i%2 == 0) echo "<b>";
		echo $para;
		if($i%2 == 0) echo "</b>";
		echo "<br />\n";
				
	}
?>
	</font>
</body>
</html>
